local _G = _G
local tonumber = _G.tonumber
local ipairs = _G.ipairs
local AceLibrary = _G.AceLibrary

local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 41492 $"):match("%d+"))

if not _G.ThreatLib_MINOR_VERSION or MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

MINOR_VERSION = _G.ThreatLib_MINOR_VERSION
_G.ThreatLib_MINOR_VERSION = nil

if not AceLibrary:IsNewVersion(MAJOR_VERSION, MINOR_VERSION) then
	return
end

for _,v in ipairs(_G.ThreatLib_funcs) do
	v()
end
_G.ThreatLib_funcs = nil

-- temporary global metadata
local ThreatLib = _G.ThreatLib
_G.ThreatLib = nil

local UpvalueFixers = ThreatLib.UpvalueFixers
ThreatLib.UpvalueFixers = nil

local function activate(self, oldLib)
	ThreatLib = self
	for _, v in _G.ipairs(UpvalueFixers) do
		v(self, oldLib)
	end
end

-- Actual registration
AceLibrary:Register(ThreatLib, MAJOR_VERSION, MINOR_VERSION, activate)

_G.collectgarbage('collect') -- get rid of the old functions and such


